
Redmine - Feature #482

Default assignee on each project

2007-11-10 02:01 - Motohiro Takayama

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 90%

Category: Issues Estimated time: 0.00 hour

Target version: 3.4.0   

Resolution: Fixed   

Description

It would nice to have a setting item to select default assignment for a new ticket,

Related issues:

Related to Redmine - Feature #10947: Default assignment based on project and ... Closed

Related to Redmine - Feature #11652: configurable issue tracker default New

Related to Redmine - Feature #2709: Modify default values Closed 2009-02-10

Related to Redmine - Feature #13789: default assignment Closed

Related to Redmine - Feature #3517: Assign an issue to person based on the is... New 2009-06-19

Related to Redmine - Defect #26072: Set default assignee before validation Closed

Related to Redmine - Feature #16351: Option to set default member for uncateg... Closed

Related to Redmine - Defect #33113: Default version and assignee are not expo... Closed

Has duplicate Redmine - Feature #448: Default user assigned to project Closed

Has duplicate Redmine - Feature #13123: Assigned default user Closed

Has duplicate Redmine - Feature #2558: Assign all new issues to myself Closed 2009-01-21

Associated revisions

Revision 16525 - 2017-04-08 10:02 - Jean-Philippe Lang

Option to set a default assignee on each project (#482).

Patch by Felix Schäfer.

Revision 16526 - 2017-04-08 10:15 - Jean-Philippe Lang

Adds tests for default assignments (#482).

Revision 16528 - 2017-04-08 18:42 - Toshi MARUYAMA

generate i18n keys (#482)

History

#1 - 2008-02-28 16:54 - Curtis Stewart

I just was asked if this feature was possible.

This would enhance the usage from a group of users, so if possible this should be set the the project or the tracker.

#2 - 2009-04-20 05:23 - James Robertson

I would like to vote for this feature, as would the people in these discussion topics I imagine:

http://www.redmine.org/boards/1/topics/3736

http://www.redmine.org/boards/1/topics/5470

#3 - 2009-04-20 20:53 - Tim Aleinikoff

I would like to see this feature in redmine.

#4 - 2009-05-05 02:37 - Eric Davis

- Category set to Issues
Good idea.  I'm thinking this would have to be per project.

#5 - 2009-05-08 02:43 - Douglas Campos

I'm looking at this now....patch is comming soon

#6 - 2009-05-08 03:25 - Zarooba Rozruba

This would be great, I have been trying to set up categories in many of projects.  Some users try to fill every field out, and categories have own

assignment.

However, half of my projects lack categories, and for those that do, only half of users bother with categories.

#7 - 2009-05-08 07:27 - Douglas Campos

I will need some help at the position of the selector in settings screen. (Visual tips)

wip branch at http://github.com/qmx/redmine/tree/ticket-482

#8 - 2009-05-13 23:40 - Adam Piotr Żochowski

Hi Douglas,

I have tried your change, am not sure if I understand how it behaves, could be that I failed backporting it to 0.8.3.

What I did to get your change going

SQL: ran

alter table projects add default_assignee_id int;

/app/models/project.rb: added line

has_one  :default_assignee, :class_name => "Member" 

/app/controllers/issue_controller.rb: added lines

@issue.assigned_to_id = @project.default_assignee.user.id

@project.default_assignee 

/app/views/_projects/_form.rhtml: added lines

<p>

<%  members = @project.members.find(:all, :include => [:role, :user]).sort %>

<%= f.select :default_assignee_id, 

    members.collect{|member| [member.name, member.user.id]}, 

    {:include_blank => :none} %>

</p>

 This is your change as far as I can read it.

Recommended change

The major change I would do is your issue_controller.rb.

You have changed that issue opens with a assigned to being already picked. This is wrong, as now category based assigned to are ignored.

Instead, I would put the default assigned to through the /app/models/issue.rb where I would add secondary fallback, If still no assigned to, use

default assigned to. This would then become something along the lines of:

  def before_create

    # default assignment based on category

    if assigned_to.nil? && category && category.assigned_to

      self.assigned_to = category.assigned_to

    end

++    if assigned_to.nil? 

++        self.assigned_to_id = @project.default_assignee_id

++    end

  end

 (not sure if proper diff syntax, hand made)

question

In model project.rb, you have defined that default_assignee is a member type, yet in database, and everywhere else, you write user.id (not

member.id) .  If that is the case, why not define the model that default_assignee is just user. Afterall, only the dropdown (in
/app/views/_projects/_form.rhtml) loads data from Members anyways.

Thank you and kind regards

#9 - 2009-05-14 13:05 - Douglas Campos

Hi Adam!

Thanks for looking at this! As I've told, this is a WIP fork...

Anyways, your suggestion rocks! I will implement it ASAP. Now I'm digging the insides of redmine, there's always room for improvement in my code!

Again, thank you for taking the time to review this.

#10 - 2009-05-26 13:31 - Douglas Campos

I've almost finished it (more tests maybe?)

Can someone review it again? (http://github.com/qmx/redmine/tree/ticket-482)

Thanks

#11 - 2009-05-27 01:23 - Eric Davis

- Status changed from New to 7

- Assignee set to Eric Davis

Thanks, I'll do a quick review of the patch.

#12 - 2009-06-10 20:44 - Adam Piotr Żochowski

I am running this on my Redmine without problems.

With patch #3461 I now have a setup that I enjoy.

Anyone can create Issue

Issue is auto routed (based on category / default assigned to)

That person either approves the issue (and re-routes to developer), or rejects it

Eric, is there anything I can help with to have this included into official Redmine. I can provide you with udiff for 0.8.4.

Kind regards

#13 - 2009-06-17 08:05 - Gregor Bader

Eric Davis wrote:

Thanks, I'll do a quick review of the patch.

 +1

Would like to see this in main branch. Another option would be to set the "Assigned to" field mandatory.

#14 - 2009-08-10 23:02 - Alex G.

Eric Davis wrote:

Thanks, I'll do a quick review of the patch.

 +1.

Maybe it makes sense to have a global setting per project with an ability to overwrite it by the tracker setting (like of defaulted assignment on the

tracker level is not set then we user project defaulted assignment)?

Reason is that there could be different departments (support groups) by tracker type - like 1st line support, technical support, R&D...

#15 - 2009-08-14 00:21 - Robert Chady

I have a strong dislike for patches in an actively developed application.  For this reason, I took a stab at converting this patch to a plugin.  It will

require an update anytime views/projects/_form.rhtml changes due to it overriding the core one.

I've requested a new hook (#3735) to be added to get around this.
The plugin was written against the latest trunk version and is at git://github.com/rchady/redmine_default_assign.git.  Comments are welcome.

#16 - 2010-02-10 16:39 - Karlis Vitols

We would be very greatful, if you could provide feedback, if this feature is to be resolved in nearest 2-3 months?

#17 - 2010-04-10 14:37 - Anton Statutov

The Plugin doesn't work with the latest Redmine version. I'm still searching the solution. Anybody have one?

#18 - 2010-06-22 17:29 - Paul Dann

Anton Statutov wrote:

The Plugin doesn't work with the latest Redmine version. I'm still searching the solution. Anybody have one?

 The plugin works OK for me.  Did you run the database migration that is required by the plugin?  (rake db:migrate_plugins)

#19 - 2010-06-24 18:21 - Raffaello Pelagalli

- File default_assignee.patch added

Didn't saw this issue before making the patch :)

Here is a patch for this

#20 - 2010-10-25 17:03 - Eric Davis

- Assignee deleted (Eric Davis)

#21 - 2010-10-29 11:05 - Oli Kessler

Raffaello Pelagalli wrote:

Didn't saw this issue before making the patch :)

Here is a patch for this

 The patch works fine for 1.0.2.stable, thank you.

The I18N is missing, though - we had to add translations in the file "config/locales/en.yml" (and other locales):

 field_default_assignee : Default Assignee

#22 - 2010-10-29 11:38 - Oli Kessler

The project jumpbox seems to be affected by this patch - it will just show the projects, this user is assigned to as the default assignee instead of all

the projects.

This is due to the line has_many :projects, :foreign_key => 'default_assignee_id', :dependent => :nullify in the user model. Is this behaviour intentional

or just a side effect?

#23 - 2010-11-24 16:14 - Frank Harper

Oli Kessler wrote:

The project jumpbox seems to be affected by this patch - it will just show the projects, this user is assigned to as the default assignee instead of

all the projects.

 Oli, I just installed the plugin (not the patch) and haven't noticed any problems yet. By project jumpbox do you mean http://hostname/redmine/projects

? This is where a user lands after clicking on "Projects" in the header.

#24 - 2011-03-30 04:48 - James Robertson

- Status changed from 7 to Resolved

- % Done changed from 0 to 100

This was implemented in the core product some time ago.

"Default assignee" drop-down list of "Information" tab of "Settings" tab for a Project

#25 - 2011-03-30 09:58 - Etienne Massip
- Status changed from Resolved to New

- % Done changed from 100 to 0

I think it's a plugin, I don't have such setting.

#26 - 2011-07-25 17:23 - Cornell Wright

+1

This is really a necessary feature. For us, issues tend to get lost sometimes until someone goes back and assigns issues without an assignee.

Etienne Massip wrote:

I think it's a plugin, I don't have such setting.

 Does anyone know what plugin this is? This would solve my problem. I can't seem to find it in the plugins directory.

#27 - 2011-07-26 10:20 - Paul Dann

You might be after this: https://github.com/rchady/redmine_default_assign

#28 - 2011-09-22 04:14 - Dave Lowndes

The plugin doesn't work for me either. It shows up, gives me a setting for the project but the setting's not saved and I still don't get a defaulty ehn

creating a new issue. Would be nice for core please!

+1

#29 - 2011-09-22 11:10 - Paul Dann

You could try using my fork on Github (https://github.com/giddie/redmine_default_assign).  Rchady seems to not be maintaining his repository any

more, and it's broken with the latest Redmines.

#30 - 2012-01-09 16:01 - Radek Antoniuk

Guys, I know that you have little development time but...

Please at least set sensible "expected" version or dates ... or merge... or do anything. For now there are already 3+ tickets for this that had been

assigned, re-assigned, dis-assigned and so on...

#31 - 2012-02-22 14:52 - Stéphane Thomas

+1

Could this be be released in trunk?

#32 - 2012-07-12 19:14 - Lucas Jenß

+1 This would be really neat.

#33 - 2012-07-19 01:08 - Chris Roemmich

I've updated the plugin Paul posted for Redmine 2.x.

https://github.com/croemmich/redmine_default_assign

#34 - 2012-09-02 21:32 - Andreas M

Chris Roemmich wrote:

I've updated the plugin Paul posted for Redmine 2.x.

https://github.com/croemmich/redmine_default_assign

 Thank you very much for this update. It works really great and should be included in redmine directly, or at least in the plugin list, as the original

version works only for redmine <1.4

#35 - 2012-11-13 15:31 - Sylvain Langlade

I wanted to post this on the project's github page, but miserably failed to do so. here is a small contribution to this plugin : a french translation. Just

add a config/locales/fr.yml file in the projet with the following content :

# French strings go here for Rails i18n

fr:

  field_default_assignee: "Assignement par defaut" 
  default_assign_text_settings: "Options" 

  default_assign_settings_help: "Assignement par defaut pour les nouveaux projets" 

  label_user: "Utilisateur" 

 And thanks for this great plugin. It really should be included in redmine directly !

#36 - 2012-11-14 13:32 - Paul Dann

Thanks Sylvain; I've added it to my repo: https://github.com/giddie/redmine_default_assign.  I've also pulled in Andreas's changes.

#37 - 2013-03-25 21:06 - Dipan Mehta

+1. I do use the default assign plugin, but wont it be a great utility in Redmine core?

#38 - 2013-05-20 11:43 - Anthony Lara

Can we use this plugin if we installed Redmine with the package Bitnami?

#39 - 2013-05-30 15:29 - Anthony Lara

I've installed the plugin, bit when i want to click on "configure" (in page Plugin), i Have got the 404 error, why?

#40 - 2013-05-30 16:10 - Paul Dann

Thanks for reporting the problem. FYI, this page is for the Redmine feature request.  For future bugs in the plugin, please create an issue here: 

https://github.com/giddie/redmine_default_assign/issues

I can see the same problem, and I'll fix it soon.

#41 - 2013-06-03 04:27 - Toshi MARUYAMA

- Related to Feature #13789: default assignment added

#42 - 2013-07-24 12:22 - Gurvan Le Dromaguet

+1 per project auto assignment is a must have for me

#43 - 2013-10-17 10:33 - Miodrag Milic

+1

The default person should be placed for each Tracker.

#44 - 2013-12-12 05:20 - Vitaliy S

+1

there must be either auto assignment to person or group (by round robin rule, one from the group should be assigned)

No progress within 6 years, impressive.

#45 - 2014-04-01 13:03 - Viktor Berke

+1

Seriously, how more trivial could it be to add an option to make << me >> the default assignee?

#46 - 2014-09-04 06:23 - Fred B

+1

#47 - 2014-09-06 21:52 - Fred B

Any developpement? Well it's been 6 years! ;)

#48 - 2014-11-27 11:11 - sch uess

+1

A per-project "default assignee" setting (not a must, though)

#49 - 2015-06-01 21:25 - J Bolt

Is it possible to have this update to a selected pool of assignee's when the status changes say from "In Progress" to "Resolved" so that it will

automatically show up for testing and closure (original assignee doesn't have to choose who gets it next... requiring them to actually think... ;-) ). I

seen this featured asked for before but haven't seen it implemented well and having a single plugin to do both auto assignment on creation and

resolving would be ++.
#50 - 2015-06-02 09:22 - Wim DePreter

J Bolt wrote:

Is it possible to have this update to a selected pool of assignee's when the status changes say from "In Progress" to "Resolved" so that it will

automatically show up for testing and closure (original assignee doesn't have to choose who gets it next... requiring them to actually think... ;-) ). I

seen this featured asked for before but haven't seen it implemented well and having a single plugin to do both auto assignment on creation and

resolving would be ++.

 Your request seems like feature #3517 (not implemented yet).

There is someone in this issue who refers to plugin http://www.redmine.org/plugins/redmine_luxury_buttons (not free)

#51 - 2015-07-01 10:29 - Toshi MARUYAMA

- Related to Feature #3517: Assign an issue to person based on the issue status added

#52 - 2015-08-31 17:28 - Peter L.

+100!

#53 - 2016-02-04 23:18 - Emrah KAVUN

Hi there,

I need this functionality. Shall I patch my Redmine 3.2 or is this integrated and I haven't seen it yet?

E

#54 - 2016-02-08 14:24 - Paul Dann

As far as I'm aware, your best bet is still to install the plugin at: https://github.com/giddie/redmine_default_assign

#55 - 2016-07-21 10:27 - Anonymous

+1

#56 - 2016-08-18 10:50 - Abel Yeom

+1

#57 - 2017-03-14 22:53 - Felix Schäfer

- File 482.patch added

Please find attached a patch to add the functionality, including migrating settings from the http://www.redmine.org/plugins/redmine_default_assign

Plugin if available.

Most things are comparable/copied from the default version mechanisms. The main difference is that there already are per-category default

assignees. As per-category is more specific than per-project, category default assignee take precedence over per-project default assignee.

#58 - 2017-03-15 03:14 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

- % Done changed from 0 to 90

This is something that has been requested by many users at Planio and it seems to be popular here on redmine.org as well. Let's include it in an

upcoming release, maybe 3.4?

#59 - 2017-03-15 08:35 - Go MAEDA

Felix, thanks for sharing the patch.

I think it would be greater if there is a option "<<Current user>>" in the dropdown. It assigns new issues to the author of the issue. There are similar

requests:

#482#note-45

default 'Assigned to:' without categories

#60 - 2017-03-15 09:04 - Felix Schäfer

Go MAEDA wrote:

Felix, thanks for sharing the patch.

I think it would be greater if there is a option "<<Current user>>" in the dropdown. It assigns new issues to the author of the issue.
 Thanks for the suggestion, this would be a nice addition.

I'm afraid this would bring some additional challenges too, as "<<Current user>>" would not handle the case were the author is anonymous (either

because the project is open or because it was received by mail with the permissions override option). So if you add "<<Current user>>" as an option

you would need to add a fallback default assigned to to make sure new issues created by anonymous will be assigned to someone too. I would prefer

to handle this in a new issue to keep this patch small enough to be added quickly.

#61 - 2017-03-16 13:32 - Go MAEDA

- Target version changed from Candidate for next minor release to 3.4.0

Felix Schäfer wrote:

I'm afraid this would bring some additional challenges too, as "<<Current user>>" would not handle the case were the author is anonymous

(either because the project is open or because it was received by mail with the permissions override option). So if you add "<<Current user>>"

as an option you would need to add a fallback default assigned to to make sure new issues created by anonymous will be assigned to someone

too. I would prefer to handle this in a new issue to keep this patch small enough to be added quickly.

 Thanks for the detailed explanation. This patch looks good as the first step.

Many people have waited for this feature for years. Let's deliver this feature in Redmine 3.4.0.

#62 - 2017-04-08 10:16 - Jean-Philippe Lang

- Subject changed from default assignment setting to Default assignee on each project

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Committed, thanks.

#63 - 2017-06-01 02:07 - Go MAEDA

- Related to Defect #26072: Set default assignee before validation added

#64 - 2017-07-21 17:15 - Luis Blasco

Hi,

I've updated two installations to the 3.4. version but I'm not able to find this new feature in the project settings. Where should I find it?

Thanks in advance.

#65 - 2017-07-21 21:17 - Jean-Philippe Lang

- File default_assignee.png added

The default assignee wan be set from the first tab of project settings. The field shows up if you have assignable users on your project (eg. members

with a role that is assignable).

This issue is closed, please open a new issue if it does not work as expected.
#66 - 2017-07-26 18:18 - Luis Blasco

Thanks for the explanation, Jean-Philippe. The issue was due to a plugin's conflict. Solved.

#67 - 2017-09-30 01:27 - Go MAEDA

- Related to Feature #16351: Option to set default member for uncategorized issues added

#68 - 2020-03-09 13:52 - Go MAEDA

- Related to Defect #33113: Default version and assignee are not exposed via projects API added

#69 - 2021-06-27 04:25 - Go MAEDA

- Has duplicate Feature #13123: Assigned default user added

#70 - 2023-03-17 07:55 - Go MAEDA

- Has duplicate Feature #2558: Assign all new issues to myself added

Files

default_assignee.patch 2.88 KB 2010-06-24 Raffaello Pelagalli

482.patch 6.62 KB 2017-03-14 Felix Schäfer

default_assignee.png 42.7 KB 2017-07-21 Jean-Philippe Lang
